import displayio, random, busio, time, board, adafruit_imageload
from adafruit_matrixportal.matrix import Matrix


# time.monotonic() is an internal clock value returned in fractional seconds
time_value = 0 #  time.monotonic() holder
grid_index = 0 #  index for tilegrid

#set up connection to the CPB
cpb_connection = busio.UART(board.TX, board.RX, baudrate=9600, timeout=0)

#setting up matrix dimensions & parameters
matrix_width = 64
matrix_height = 32
image_animation_timer = 0.5

#creating the matrix display
matrix = Matrix(width=matrix_width, height=matrix_height, bit_depth=6)
display = matrix.display

def get_bmp(file):
    numb_images = 3 #You should change this based on the number of images per bmp file you have
    bitmap_file = file
    bitmap = displayio.OnDiskBitmap(open("/"+bitmap_file+".bmp", "rb"))

    image_bit, image_pal = adafruit_imageload.load("/"+bitmap_file+".bmp", bitmap=displayio.Bitmap, palette=displayio.Palette)
    image_grid = displayio.TileGrid(image_bit, pixel_shader=image_pal, width=1, height=1, tile_height=matrix_height, tile_width=matrix_width, default_tile=0, x=0, y=0)

    group = displayio.Group()
    group.append(image_grid)

    display.show(group)
    return image_grid, numb_images


animations = ["Yes", "No", "Hungry", "Thirsty", "Bathroom", "Reconnecting"]
print("Test")

while True:



    get_bmp("Reconnecting") #Want the screen to start as "reconnecting"
    message = ""
    incoming_bytes = cpb_connection.in_waiting
    #print(incoming_bytes)

    if incoming_bytes:
        bytes_in = cpb_connection.readline()
        print(bytes_in, bytes_in.decode("utf-8"))
        #print("Received: ", bytes_in.decode().decode())
        message = str(bytes_in.decode())
        print(message)

    print("Message: " + str(message))

    if message == "-1":
        message =   "5"
    #If the message is empty that means that we have not received anything from the client CPB
    #In that case show the reconnecting screen indicating that we are waiting for input
    if(message == ""):
        image_grid, number_of_images = get_bmp("Reconnecting")
    else:
        image_grid, number_of_images = get_bmp(animations[int(message)])
    timer_finished = time.time() + 10 #Determines how long the selected animation will last on the screen
    while time.time() < timer_finished:
        if (time_value + image_animation_timer) < time.monotonic():
            image_grid[0] = grid_index
            time_value = time.monotonic()
            grid_index += 1
            if grid_index > number_of_images-1:
                grid_index = 0
    grid_index = 0
    get_bmp("Black")
